%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Convert_Rutman_To_Bar(Fastener_Index)

global ErrCode;

global DB_ELEMENTS;
global DB_PSETS;
global DB_NODES;

global AT_ELEMENTS;
global AT_PSETS;
global AT_NODES;

global DB_FASTENERS;

% --- Исправление офсетов точек смятия ---

[temp_counter_1, temp_counter_2, temp_counter_3] = Repair_RutFast_Offsets(Fastener_Index); %#ok<ASGLU>

if (ErrCode < 0)
    return;
end

% --- Получение списка систем координат, использующихся в болте ---

Fastener_Coord_list = zeros(100,1);

counter = 0;

% Системы координат ориентации BUSH-элементов
for i=1:DB_FASTENERS{Fastener_Index}.N_layers
        
    for j=1:size(DB_FASTENERS{Fastener_Index}.Bush_elements{i},1)

        counter = counter + 1;
        Fastener_Coord_list(counter,1) = Get_Bush_Ori_CID(DB_FASTENERS{Fastener_Index}.Bush_elements{i}(j));

    end
    
end

% Системы координат в узлах
Node_list = [DB_FASTENERS{Fastener_Index}.Shank_nodes; DB_FASTENERS{Fastener_Index}.Additional_nodes; DB_FASTENERS{Fastener_Index}.Joint_nodes];

for i=1:size(Node_list,1)
    
    counter = counter + 1;
    Fastener_Coord_list(counter,1) = DB_NODES{AT_NODES(Node_list(i))}.Analysis_CID;
    
    counter = counter + 1;
    Fastener_Coord_list(counter,1) = DB_NODES{AT_NODES(Node_list(i))}.Reference_CID;
    
end

% Обработка массива Fastener_Coord_list
if (counter == 0)
    
    Fastener_Coord_list = [];
    
else
    
    % Финализация массива
    Fastener_Coord_list = Fastener_Coord_list(1:counter);
    
    % Оставляем уникальные элементы
    Fastener_Coord_list = unique(Fastener_Coord_list);
    
    % Исключаем глобальную систему координат
    Fastener_Coord_list = setdiff(Fastener_Coord_list, 0);
    
    if (isempty(Fastener_Coord_list))
        Fastener_Coord_list = [];
    end
    
end

% --- Получение списка property sets BUSH-элементов, использующихся в болте ---

Fastener_BUSH_PSET_list = zeros(100,1);

counter = 0;

for i=1:DB_FASTENERS{Fastener_Index}.N_layers
        
    for j=1:size(DB_FASTENERS{Fastener_Index}.Bush_elements{i},1)

        counter = counter + 1;
        Fastener_BUSH_PSET_list(counter,1) = DB_ELEMENTS{AT_ELEMENTS(DB_FASTENERS{Fastener_Index}.Bush_elements{i}(j))}.Prop_ID;

    end
    
end

% Обработка массива Fastener_BUSH_PSET_list
if (counter == 0)
    
    Fastener_BUSH_PSET_list = [];
    
else
    
    % Финализация массива
    Fastener_BUSH_PSET_list = Fastener_BUSH_PSET_list(1:counter);
    
    % Оставляем уникальные элементы
    Fastener_BUSH_PSET_list = unique(Fastener_BUSH_PSET_list);
    
end


% --- Удаление BUSH-элементов ---

% Удаление элементов
for i=1:DB_FASTENERS{Fastener_Index}.N_layers

    Append_To_Output(PCL_Elm_Delete(DB_FASTENERS{Fastener_Index}.Bush_elements{i}));
    DB_Elm_Delete(DB_FASTENERS{Fastener_Index}.Bush_elements{i});

    if (ErrCode < 0)
        return;
    end

end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Bush_elements = [];

% --- Удаление property sets ---

if (~isempty(Fastener_BUSH_PSET_list))
    
    for i=1:size(Fastener_BUSH_PSET_list,1)
    
        [FD_Flag, Number] = DB_PSet_Is_FD(Fastener_BUSH_PSET_list(i)); %#ok<ASGLU>
        Pset_Name = DB_PSETS{AT_PSETS(Fastener_BUSH_PSET_list(i))}.Patran_name;

        % Если property set имеет префикс FD
        if (FD_Flag == 1)

            Append_To_Output(PCL_PSet_Delete(Pset_Name));
            DB_PSet_Delete(Fastener_BUSH_PSET_list(i));

            if (ErrCode < 0)
                return;
            end

        end
    
    end
    
end

% --- Удаление RBAR ---

MPC_list = DB_FASTENERS{Fastener_Index}.RBAR_MPCs;

Append_To_Output(PCL_MPC_Delete(MPC_list));
DB_MPC_Delete(MPC_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.RBAR_MPCs = [];
DB_FASTENERS{Fastener_Index}.Head_MPC_Index = [];

% --- Соединение стержня болта с остальной сеткой ---

Old_shank_nodes = DB_FASTENERS{Fastener_Index}.Shank_nodes(2:DB_FASTENERS{Fastener_Index}.N_layers+1);

Element_list = DB_FASTENERS{Fastener_Index}.Shank_elements;
Node_list = Old_shank_nodes;
Target_Node_list = DB_FASTENERS{Fastener_Index}.Additional_nodes;

Append_To_Output(PCL_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list));
DB_Elm_Modify_Conn(Element_list, Node_list, Target_Node_list);

if (ErrCode < 0)
    return;
end

% --- Удаление двух крайних элементов ---

Elm_list = DB_FASTENERS{Fastener_Index}.Shank_elements(1);

Append_To_Output(PCL_Elm_Delete(Elm_list));
DB_Elm_Delete(Elm_list);

if (ErrCode < 0)
    return;
end

Elm_list = DB_FASTENERS{Fastener_Index}.Shank_elements(DB_FASTENERS{Fastener_Index}.N_layers+1);

Append_To_Output(PCL_Elm_Delete(Elm_list));
DB_Elm_Delete(Elm_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Shank_elements = DB_FASTENERS{Fastener_Index}.Shank_elements(2:DB_FASTENERS{Fastener_Index}.N_layers);

% --- Удаление старых узлов ---

Node_list = DB_FASTENERS{Fastener_Index}.Shank_nodes;

Append_To_Output(PCL_Node_Delete(Node_list));
DB_Node_Delete(Node_list);

if (ErrCode < 0)
    return;
end

% Внесение изменений в базу данных крепежа
DB_FASTENERS{Fastener_Index}.Shank_nodes = DB_FASTENERS{Fastener_Index}.Additional_nodes;
DB_FASTENERS{Fastener_Index}.Additional_nodes = [];

% --- Изменение систем координат узлов ---

Node_list = [DB_FASTENERS{Fastener_Index}.Shank_nodes; DB_FASTENERS{Fastener_Index}.Joint_nodes];

New_Reference_Coord = 0;
New_Analysis_Coord = 0;

Append_To_Output(PCL_Node_Edit_Coord(Node_list, New_Reference_Coord, New_Analysis_Coord));
DB_Node_Edit_Coord(Node_list, New_Reference_Coord, New_Analysis_Coord);

if (ErrCode < 0)
    return;
end

% --- Удаление систем координат, использовавшихся в болте ---

if (~isempty(Fastener_Coord_list))

    for i=1:size(Fastener_Coord_list,1)

        % Если СК не задействована
        if (DB_Coord_Is_Free(Fastener_Coord_list(i)))

            % Удаление системы координат
            Append_To_Output(PCL_Coord_Delete(Fastener_Coord_list(i)));
            DB_Coord_Delete(Fastener_Coord_list(i));

            if (ErrCode < 0)
                return;
            end

        end

    end

end

% --- Заполнение топологии крепежа ---

DB_FASTENERS{Fastener_Index}.topology = 'bar_fastener';
